\ *******************************************************************
\                                                                   *
\    Filename:      core.fth                                        *
\    Date:          17.1.2009                                       *
\    FF Version:    4.3                                             *
\    MCU:           dsPIC30F                                        *
\    Copyright:     Mikael Nordman                                  *
\    Author:        Mikael Nordman                                  *
\ *******************************************************************
\ FlashForth is licensed according to the GNU General Public License*
\ *******************************************************************
\ Some extra core words
-core
marker -core
hex ram

\ Interpret a string. The string must be in ram
: evaluate ( caddr n -- )
  'source 2@ >r >r >in @ >r
  interpret
  r> >in ! r> r> 'source 2!
;

\ Define TO
: to is ;

: forget ( --- name )
  bl word latest @ (f) 0= ?abort?
  cfa>nfa nfa>lfa dup @ 0= ?abort?
  dup flash dp ! @ latest ! ram
;

: fill ( addr n c -- ) \ fill addr to addr+n with c
  rot !p>r swap
  for
    dup pc! p+
  next
  r>p drop 
;
: erase  ( addr n -- )
  0 fill
;

: blanks  ( addr n -- )
  bl fill
;

: ?dup ( x -- 0 | x x )
  dup if dup then 
;

: pick ( xu ... x0 u -- xu ... x0 xu) 2* 2+ sp@ swap - @ ;

